function [vChain]=fMarkov(mTran,nSim,vInitialState,vNumId)
%  Function to generate a simulation from a Markov chain
%  mTran is transition matrix
%  nSim is number of periods to simulate
%  vInitialState is initial state
%  vNumId is the number corresponding to each state
%
% (C.) Enrique G. Mendoza & Sergio Villalvazo, 2018

[nRowTran nColTran] = size(mTran);

vUniform = rand(nSim-1,1);
vState = zeros(nRowTran,1);
vState(vInitialState) = 1;
mCum = mTran*triu(ones(size(mTran)));
mState = zeros(nRowTran,nSim-1);

for iSim=1:length(vUniform)
  mState(:,iSim) = vState;
  vProb = [0 vState'*mCum];
  vState = ((vUniform(iSim)<=vProb(2:nRowTran+1)).*(vUniform(iSim)>vProb(1:nRowTran)))';
end

vChain=vNumId*mState;
